/*
 * INPUT: file .m contenente la mesh a triangoli:
 *        Vertex  NUM  x y z 
 *                .......
 *        Normal  NUM  x y z 
 *                .......
 *        Face    NUM f1 f2 f3 
 *                .......
 * OUPUT: visualizzazione della mesh in una finestra OpenGL
 */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <sys/types.h>
#include <GL/glut.h>

int 	face[150000][3]; 	/* global structure triangular faces */
float 	vertici[150000][3]; 	/* global structure triangular vertices */
float 	normali[150000][3]; 	/* global structure triangular normals */
int 	listname;
int 	gntris;	

void display()
{
    static int iter=0;

    glClear(GL_DEPTH_BUFFER_BIT|GL_COLOR_BUFFER_BIT);

    glPushMatrix();
    glRotatef(iter, 0,1,0);
    iter++;
    
    glCallList(listname); 
    glPopMatrix();
    glutSwapBuffers();

}

void idle()
{
        glutPostRedisplay();
}


void init()
{
    int i;
    // crea la display list 
    printf("Creazione display list .. \n");
    listname=glGenLists(1);
    glNewList(listname,GL_COMPILE);
    for (i = 0; i < gntris; i++) {
	int ii, ids[3];

    	ids[0] = face[i][0];
    	ids[1] = face[i][1];
  	ids[2] = face[i][2];

   	glBegin(GL_TRIANGLES);
    	for (ii = 0; ii < 3; ii++) {
     //  		glNormal3f(normali[ids[ii]][0],normali[ids[ii]][1],normali[ids[ii]][2]);
       	    	glVertex3f(vertici[ids[ii]][0],vertici[ids[ii]][1],vertici[ids[ii]][2]);
    	}
    	glEnd();

// visualizzazione wireframe
//    	glDisable(GL_LIGHTING);
//    	glPolygonOffset(-1,-1);
//    	glEnable(GL_POLYGON_OFFSET_LINE);
//    	glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);
//    	glColor3f(1,0,0);
//

//    	glBegin(GL_TRIANGLES);
//    	for (ii = 0; ii < 3; ii++) {
//      // 		glNormal3f(normali[ids[ii]][0],normali[ids[ii]][1],normali[ids[ii]][2]);
//       	    	glVertex3f(vertici[ids[ii]][0],vertici[ids[ii]][1],vertici[ids[ii]][2]);
//    	}
//    	glEnd();

    }

//    glEnable(GL_LIGHTING);
//    glDisable(GL_POLYGON_OFFSET_LINE);
    glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
    glEndList();
}


int main (int argc, char** argv)
{
    	int i,nrighe;
        FILE * idf;
	char s[6];
        float a,b,c;
        int nvert,nnorm,noused;
	
        //apertura dei file
        printf("Apertura del file...\n");
        //if ((idf=fopen( argv[1], "r")) == NULL){
        if ((idf=fopen( "data/cactus.m", "r")) == NULL){
                perror("file non trovato\n");
                exit (1);
        }
        i=0;
        gntris=0;
        nvert=0;
        nnorm=0;
        while (!feof(idf)){
        fscanf(idf,"%s %d %f %f %f",s, &noused, &a,&b,&c);
        switch (s[0]) {
          case 'V':
                vertici[nvert][0]=a;
                vertici[nvert][1]=b;
                vertici[nvert][2]=c;
                nvert++;
                break;
          case 'N':
                normali[nnorm][0]=-a;
                normali[nnorm][1]=-b;
                normali[nnorm][2]=-c;
                nnorm++;
                break;
          case 'F':
                face[gntris][0]=(int)a-1;
                face[gntris][1]=(int)b-1;
                face[gntris][2]=(int)c-1;
                gntris++;
                break;
          case 'E':
                printf(" Edge not used! \n");
                break;
          default:
                printf(" ERROR: Reading file \n");
                break;
          }
        }
    nrighe=nvert+nnorm+gntris;
    gntris=gntris-1;
    printf("Chiusura del file...Verteces %d Normals %d Faces %d %d \n",nvert,nnorm,gntris,nrighe);
    fclose(idf);
    glutInit(&argc,argv);
    glutInitDisplayMode(GLUT_RGBA|GLUT_DEPTH|GLUT_DOUBLE);
    glutInitWindowSize(500,500);
    glutCreateWindow("Model Viewer ");
    glutDisplayFunc(display);
    glutIdleFunc(idle);
    init();
    glEnable(GL_LIGHTING);
    glEnable(GL_LIGHT0);
    glEnable(GL_DEPTH_TEST);
    glEnable(GL_NORMALIZE);
    glShadeModel(GL_SMOOTH);
    glutMainLoop();

}

